Program Pix2Demo;

Uses
	Pix2Main,Pix2Text,Crt;

Type
	Scroller=Object
   	Txt:Array[1..50] Of String;
      NumStr:Integer;
      X,Y:LongInt;
      Constructor Init;
		Procedure AddStr(S:String);
      Procedure Display;
   End;
   Strs=Record
   	X,Y,Lev:Integer;
   End;
   StarField=Object
   	Stars:Array[1..2000] Of Strs;
      NumStars:Integer;
      Ctr:LongInt;
      Constructor Init(Lev,SByLev:Integer);
      Procedure Display;
   End;

Constructor Scroller.Init;
Begin
	NumStr:=0;
   X:=320;
   Y:=5;
End;

Procedure Scroller.AddStr(S:String);
Begin
	Inc(NumStr);
   Txt[NumStr]:=S;
End;

Procedure Scroller.Display;
Var
	C:Integer;
	L:LongInt;
Begin
   L:=X;
	For C:=1 To NumStr Do
   Begin
		If (L+PixLength(Txt[C])>=0) And (L<320) Then
			PixWriteS(L,Y,15,8,Txt[C]);
		L:=L+PixLength(Txt[C])+PixLength(' ')*2;
   End;
   Dec(X,1);
End;

Constructor StarField.Init(Lev,SByLev:Integer);
Var
	C,L,S:Integer;
Begin
	C:=1;
   NumStars:=Lev*SByLev;
   For L:=1 To Lev Do
   	For S:=1 To SByLev Do
      Begin
      	Stars[C].X:=Random(320);
         Stars[C].Y:=Random(200);
         Stars[C].Lev:=L;
         Inc(C);
      End;
	Ctr:=0;
End;

Procedure StarField.Display;
Var
	C:Integer;
Begin
	For C:=1 To NumStars Do
   Begin
      With Stars[C] Do
      Begin
	   	PixPutPixel(X,Y,Lev+15);
	      Dec(X,4-Lev);
         If X<0 Then
         Begin
         	X:=X+320;
            Y:=Random(200);
         End;
      End;
   End;
End;

Type
	TQix=Object
   	X1,X2,Y1,Y2:Array[1..10] Of Integer;
      XD1,XD2,YD1,YD2:Integer;
      BCol:Byte;
		Constructor Init(Col:Byte);
      Procedure Display;
   End;

Constructor TQix.Init;
Var
	X,Y,C:Integer;
Begin
	X:=Random(320);
   Y:=Random(200);
   For C:=1 To 10 Do
   Begin
   	X1[C]:=X;
      Y1[C]:=Y;
   End;
	X:=Random(320);
   Y:=Random(200);
   For C:=1 To 10 Do
   Begin
   	X2[C]:=X;
      Y2[C]:=Y;
   End;
   BCol:=Col;
	XD1:=Random(6)-3;
	If XD1=0 Then
   	XD1:=3;
   YD1:=Random(6)-3;
   If YD1=0 Then
   	YD1:=3;
   XD2:=Random(6)-3;
   If XD2=0 Then
   	XD2:=3;
   YD2:=Random(6)-3;
   If YD2=0 Then
   	YD2:=3;
End;

Procedure TQix.Display;
Var
	C:Integer;
Begin
	For C:=10 DownTo 2 Do
   Begin
   	X1[C]:=X1[C-1]; X2[C]:=X2[C-1]; Y1[C]:=Y1[C-1]; Y2[C]:=Y2[C-1];
   End;
   Inc(X1[1],XD1*2);
   Inc(Y1[1],YD1*2);
   Inc(X2[1],XD2*2);
   Inc(Y2[1],YD2*2);
   If X1[1]<0 Then XD1:=Random(3)+1;
   If X1[1]>319 Then XD1:=Random(3)-3;
   If X2[1]<0 Then XD2:=Random(3)+1;
   If X2[1]>319 Then XD2:=Random(3)-3;

   If Y1[1]<0 Then YD1:=Random(3)+1;
   If Y1[1]>199 Then YD1:=Random(3)-3;
   If Y2[1]<0 Then YD2:=Random(3)+1;
   If Y2[1]>199 Then YD2:=Random(3)-3;
   For C:=10 DownTo 1 Do
		PixLine(X1[C],Y1[C],X2[C],Y2[C],BCol+C-1);
End;


Var
	S,S2:Scroller;
   Sf:StarField;
   Timer:LongInt;
   R,G,B:Byte;
   W1,W2,W3:Byte;
   C,D:Integer;
   Qix:Array[1..7] Of TQix;

Begin
   Randomize;
	If Not PixOpen(2) Then
   Begin
   	PixScreen('Not enough memory');
      WriteLn('Sorry, you don''t have enough memory to run this demo.');
      Exit;
   End;
   S.Init;
   S.AddStr('Welcome to the Pix2 Demo.');
   S.AddStr('This Demo is intended to show the powerful capabilities that Pix2 can provide.');
   S.AddStr('         ');
   S.AddStr('First, let''s draw some primitives.');
   S.AddStr('Note that clipping is applied to the screen''s borders.');
   S.AddStr('Also note that all the work is done on a virtual page, then dumped to screen.');
   S.AddStr('Let resize the clipping rectangle.');
	S.AddStr('Note that the yellow rectangle is drawn with PixBox, and isn''t draw by PixSetClip.');
	S.AddStr('                     ');
   S.AddStr('As you can see, incredible speed can be obtained using Pix2.');

   S2.Init;
   S2.AddStr('Free memory for sprites: '+PixIntToStr(MemAvail));
   S2.Y:=96;

   Sf.Init(3,650);
   PixSelPage(1);
   Timer:=0;
   PixGetRgb(9,R,G,B);
   PixSetRgb(16,0,0,0);
   PixSetRgb(17,0,0,0);
   PixSetRgb(18,0,0,0);
   For D:=20 To 29 Do
   	PixSetRgb(D,(30-D)*5,0,0);
   For D:=30 To 39 Do
   	PixSetRgb(D,0,(40-D)*5,0);
   For D:=40 To 49 Do
   	PixSetRgb(D,0,0,(50-D)*5);
   For D:=50 To 59 Do
   	PixSetRgb(D,0,(60-D)*5,(60-D)*5);
   For D:=60 To 69 Do
   	PixSetRgb(D,(70-D)*5,0,(70-D)*5);
   For D:=70 To 79 Do
   	PixSetRgb(D,(80-D)*5,(80-D)*5,0);
   For D:=80 To 89 Do
   	PixSetRgb(D,(90-D)*5,(90-D)*5,(90-D)*5);
   Qix[1].Init(20);
   Qix[2].Init(30);
   Qix[3].Init(40);
   Qix[4].Init(50);
   Qix[5].Init(60);
   Qix[6].Init(70);
   Qix[7].Init(80);
   W1:=0;
   W2:=0;
   W3:=0;
   C:=0;
   Repeat
      Inc(Timer);
   	PixFillPage(9);

      If (Timer>500) And (Timer<570) Then
      Begin
      	If R>0 Then Dec(R);
      	If G>0 Then Dec(G);
      	If B>0 Then Dec(B);
         PixSetRgb(9,R,G,B);
      End;
      If (Timer>640) And (Timer<700) Then
      Begin
      	If W1<20 Then Inc(W1);
         If W2<40 Then Inc(W2);
         Inc(W3);
         PixSetRGB(16,W3,W3,W3);
         PixSetRGB(17,W2,W2,W2);
         PixSetRGB(18,W1,W1,W1);
      End;
      If (Timer>1400) And (Timer<1450) Then
      Begin
         Inc(C);
         PixSetClip(C,C,319-C,199-C);
         Inc(S.Y);
      End;
      If (Timer>1800) And (Timer<1849) Then
      Begin
         Dec(C);
         PixSetClip(C,C,319-C,199-C);
         Dec(S.Y);
      End;

      If (Timer>570) Then
      	Sf.Display;
      If (Timer>2000) Then
      Begin
      	Qix[1].Display;
         Qix[2].Display;
         Qix[3].Display;
         Qix[4].Display;
         Qix[5].Display;
         Qix[6].Display;
         Qix[7].Display;
      End;
      If Timer=3000 Then
      	PixGetPalette(@PixPal);
      If Timer>3000 Then
      Begin
      	PixFadeOutPalette(@PixPal);
         PixSetPalette(@PixPal);
      End;

		If (Timer<2500) Then
			S.Display;
      If (Timer>2500) Then
      	S2.Display;
(*      PixWrite(1+c,190-c,15,PixIntToStr(Timer));*)
      If (Timer>800) And (Timer<1200) And (Timer mod 10>4) Then
      	PixWriteCenterS(190,15,8,'Star count: 1,950 !');
      If(Timer>1400) Then
      	PixBox(C,C,319-C,199-C,14);
      PixWaitVSync;
      PixDump;
   Until KeyPressed Or (Timer=3070);
   While KeyPressed Do ReadKey;
   PixGetPalette(@PixPal);
   For R:=1 To 63 Do
   Begin
		PixFadeOutPalette(@PixPal);
      PixSetPalette(@PixPal);
   End;
   PixClose;
End.