Unit Pix2Gui;

{$I-}
{$G+}
{$R-}
{$Q-}

(* The {$DEFINE PIXDEBUG} should be here *)
{$DEFINE PIXDEBUG}

Interface

Type
	PixButton=Object
   	X1,Y1,X2,Y2:Integer;
      Cap:String;
      Pressed,Clicked,Wahoo:Boolean;
      Constructor Init(nX1,nY1,Wd,Hg:Integer;nCap:String);
      Procedure Draw;
      Function Idle:Boolean;
		Function Check:Boolean;
	End;
   PixCheckBox=Object
   	X1,Y1:Integer;
      Cap:String;
      Pressed,Clicked,Check:Boolean;
      Constructor Init(nX1,nY1:Integer;nCap:String;Default:Boolean);
      Procedure Draw;
      Function Idle:Boolean;
   End;

Procedure PixDrawPanel(X1,Y1,X2,Y2:Integer);


Var
	PixGuiCol1,PixGuiCol2,PixGuiCol3:Byte;

Implementation

Uses
	Pix2Main,Pix2Text,Pix2Mous;

Constructor PixButton.Init(nX1,nY1,Wd,Hg:Integer;nCap:String);
Begin
	X1:=nX1;
   Y1:=nY1;
   X2:=nX1+Wd-1;
   Y2:=nY1+Hg-1;
   Clicked:=False;
   Pressed:=False;
   Wahoo:=False;
   Cap:=nCap;
   Draw;
End;

Procedure PixButton.Draw;
Begin
   If Not Pressed Then
   Begin
		PixLine(X1,Y1,X2,Y1,PixGuiCol3);
	   PixLine(X1,Y1,X1,Y2,PixGuiCol3);
	   PixLine(X1,Y2,X2,Y2,PixGuiCol1);
	   PixLine(X2,Y1+1,X2,Y2,PixGuiCol1);
		PixFilledBox(X1+1,Y1+1,X2-1,Y2-1,PixGuiCol2,PixGuiCol2);
		PixWriteS(X1+((X2-X1+1)-PixLength(Cap)) Div 2,Y1+((Y2-Y1+1)-PixHeight(Cap)) Div 2,15,8,Cap);
	End
   Else
   Begin
		PixLine(X1,Y1,X2,Y1,PixGuiCol1);
	   PixLine(X1,Y1,X1,Y2,PixGuiCol1);
	   PixLine(X1,Y2,X2,Y2,PixGuiCol3);
	   PixLine(X2,Y1+1,X2,Y2,PixGuiCol3);
	   PixFilledBox(X1+1,Y1+1,X2-1,Y2-1,PixGuiCol2,PixGuiCol2);
      PixWriteS(X1+((X2-X1+1)-PixLength(Cap)) Div 2+1,Y1+((Y2-Y1+1)-PixHeight(Cap)) Div 2+1,15,8,Cap);
   End;
End;

Function PixButton.Idle:Boolean;
Var
	Inside:Boolean;
Begin
   Idle:=False;
	Inside:=(MouseX>X1)And(MouseY>Y1)And(MouseX<X2)And(MouseY<Y2);
   If Inside Then
   Begin
      If (Not Clicked) And (MouseB1) Then
      Begin
      	Pressed:=True;
         Clicked:=True;
         Idle:=True;
      End;
      If Clicked And (MouseB1) And (Not Pressed) Then
      Begin
      	Pressed:=True;
         Idle:=True;
      End;
      If Clicked And (Not MouseB1) Then
      Begin
      	Pressed:=False;
         Clicked:=False;
         Wahoo:=True;
         Idle:=True;
      End;
   End
   Else
   Begin
      If (Not MouseB1) And Clicked Then
      Begin
      	Clicked:=False;
         Idle:=True;
      End;
   	If Pressed Then
      Begin
      	Pressed:=False;
         Idle:=True;
      End;
	End;
End;

Constructor PixCheckBox.Init(nX1,nY1:Integer;nCap:String;Default:Boolean);
Begin
	X1:=nX1;
   Y1:=nY1;
   Clicked:=False;
   Pressed:=False;
   Check:=Default;
   Cap:=nCap;
   Draw;
End;

Procedure PixCheckBox.Draw;
Begin
   If Not Pressed Then
   Begin
		PixLine(X1,Y1,X1+5,Y1,PixGuiCol3);
	   PixLine(X1,Y1,X1,Y1+5,PixGuiCol3);
	   PixLine(X1,Y1+5,X1+5,Y1+5,PixGuiCol1);
	   PixLine(X1+5,Y1+1,X1+5,Y1+5,PixGuiCol1);
	   PixFilledBox(X1+1,Y1+1,X1+4,Y1+4,PixGuiCol2,PixGuiCol2);
   	If Check Then PixPutPixel(X1+2,Y1+2,15);
	End
   Else
   Begin
		PixLine(X1,Y1,X1+5,Y1,PixGuiCol1);
	   PixLine(X1,Y1,X1,Y1+5,PixGuiCol1);
	   PixLine(X1,Y1+5,X1+5,Y1+5,PixGuiCol3);
	   PixLine(X1+5,Y1+1,X1+5,Y1+5,PixGuiCol3);
	   PixFilledBox(X1+1,Y1+1,X1+4,Y1+4,PixGuiCol2,PixGuiCol2);
   	If Check Then PixPutPixel(X1+3,Y1+3,15);
   End;
   PixWriteS(X1+8,Y1+3-PixHeight(Cap) Div 2,15,8,Cap);
End;

Function PixCheckBox.Idle:Boolean;
Var
	Inside:Boolean;
Begin
   Idle:=False;
	Inside:=(MouseX>=X1)And(MouseY>=Y1)And(MouseX<=X1+PixLength(Cap)+7)And(MouseY<=Y1+5);
   If Inside Then
   Begin
      If (Not Clicked) And (MouseB1) Then
      Begin
      	Pressed:=True;
         Clicked:=True;
         Idle:=True;
      End;
      If Clicked And (MouseB1) And (Not Pressed) Then
      Begin
      	Pressed:=True;
         Idle:=True;
      End;
      If Clicked And (Not MouseB1) Then
      Begin
      	Pressed:=False;
         Clicked:=False;
         Check:=Not Check;
         Idle:=True;
      End;
   End
   Else
   Begin
      If (Not MouseB1) And Clicked Then
      Begin
      	Clicked:=False;
         Idle:=True;
      End;
   	If Pressed Then
      Begin
      	Pressed:=False;
         Idle:=True;
      End;
	End;
End;

Function PixButton.Check:Boolean;
Begin
	If Wahoo Then Check:=True Else Check:=False;
   Wahoo:=False;
End;


Procedure PixDrawPanel(X1,Y1,X2,Y2:Integer);
Begin
	PixLine(X1,Y1,X2,Y1,PixGuiCol3);
   PixLine(X1,Y1,X1,Y2,PixGuiCol3);
   PixLine(X1,Y2,X2,Y2,PixGuiCol1);
   PixLine(X2,Y1+1,X2,Y2,PixGuiCol1);
   PixFilledBox(X1+1,Y1+1,X2-1,Y2-1,PixGuiCol2,PixGuiCol2);
End;

Begin
	PixGuiCol1:=133;
   PixGuiCol2:=197;
   PixGuiCol3:=245;
End.