Unit Pix2Kbd;

{$I-}
{$G+}
{$R-}
{$Q-}

(* The {$DEFINE PIXDEBUG} should be here *)
{$DEFINE PIXDEBUG}

Interface

Procedure PixInstallKey;
Procedure PixRemoveKey;
Procedure PixWaitForKey(WKey:Byte);
Function PixWaitAnyKey:Byte;
Function PixKeyPressed:Boolean;

Var
	Key:Array[1..255] Of Boolean;
	CtrlAltDelEnabled:Boolean;

Const
  keySysReq      = $54;  keyCapsLock    = $3A;  keyNumLock     = $45;
  keyScrollLock  = $46;  keyLeftCtrl    = $1D;  keyLeftAlt     = $38;
  keyLeftShift   = $2A;  keyRightCtrl   = $9D;  keyAltGr       = $B8;
  keyRightShift  = $36;  keyEsc         = $01;  keyBackspace   = $0E;
  keyEnter       = $1C;  keySpace       = $39;  keyTab         = $0F;
  keyF1          = $3B;  keyF2          = $3C;  keyF3          = $3D;
  keyF4          = $3E;  keyF5          = $3F;  keyF6          = $40;
  keyF7          = $41;  keyF8          = $42;  keyF9          = $43;
  keyF10         = $44;  keyF11         = $57;  keyF12         = $58;
  keyA           = $1E;  keyB           = $30;  keyC           = $2E;
  keyD           = $20;  keyE           = $12;  keyF           = $21;
  keyG           = $22;  keyH           = $23;  keyI           = $17;
  keyJ           = $24;  keyK           = $25;  keyL           = $26;
  keyM           = $32;  keyN           = $31;  keyO           = $18;
  keyP           = $19;  keyQ           = $10;  keyR           = $13;
  keyS           = $1F;  keyT           = $14;  keyU           = $16;
  keyV           = $2F;  keyW           = $11;  keyX           = $2D;
  keyY           = $15;  keyZ           = $2C;  key1           = $02;
  key2           = $03;  key3           = $04;  key4           = $05;
  key5           = $06;  key6           = $07;  key7           = $08;
  key8           = $09;  key9           = $0A;  key0           = $0B;
  keyMinus       = $0C;  keyEqual       = $0D;  keyLBracket    = $1A;
  keyRBracket    = $1B;  keySemicolon   = $27;  keyTick        = $28;
  keyApostrophe  = $29;  keyBackslash   = $2B;  keyComma       = $33;
  keyPeriod      = $34;  keySlash       = $35;  keyInsert      = $D2;
  keyDelete      = $D3;  keyHome        = $C7;  keyEnd         = $CF;
  keyPageUp      = $C9;  keyPageDown    = $D1;  keyArrowLeft   = $CB;
  keyArrowRight  = $CD;  keyArrowUp     = $C8;  keyArrowDown   = $D0;
  keyKeypad0     = $52;  keyKeypad1     = $4F;  keyKeypad2     = $50;
  keyKeypad3     = $51;  keyKeypad4     = $4B;  keyKeypad5     = $4C;
  keyKeypad6     = $4D;  keyKeypad7     = $47;  keyKeypad8     = $48;
  keyKeypad9     = $49;  keyKeypadComma = $53;  keyKeypadStar  = $37;
  keyKeypadMinus = $4A;  keyKeypadPlus  = $4E;  keyKeypadEnter = $9C;
  keyCtrlPrtScr  = $B7;  keyShiftPrtScr = $B7;  keyKeypadSlash = $B5;

Implementation

Uses
	Dos;

Var
	OldInt09:Procedure;
	E0Flag:Byte;
	KeyPr:Boolean;
   KbdInstalled:Boolean;
   OldExitProc:Pointer;

Procedure Hooked09; Interrupt;
Var
	Car:Byte;
   Rbt:Procedure;
	W:^Word;
Begin
	Car:=Port[$60];
   If Car=$E0 Then
   	E0Flag:=128
	Else
   Begin
		If Car And $80=0 Then
      Begin
	   	Key[Car+E0Flag]:=True;
         KeyPr:=True;
      End
	   Else
	   	Key[(Car And (Not $80))+E0Flag]:=False;
      E0Flag:=0;
	End;
   Car:=Port[$61];
   Port[$61]:=Car Or $80;
	Port[$61]:=Car;
   Port[$20]:=$20;
	If CtrlAltDelEnabled Then
   	If (Key[keyRightCtrl] or Key[keyLeftCtrl]) And (Key[keyLeftAlt] Or Key[keyAltGr])
			And Key[keyDelete] Then
      Begin
			W:=Ptr($0040,$0072);
			W^:=0;
			@Rbt:=Ptr($FFFF,$0000);
			Rbt;
		End;
End;

Procedure KbdAutoClose; Far;
Begin
	PixRemoveKey;
End;

Procedure PixInstallKey;
Var
	C:Integer;
Begin
	If KbdInstalled Then Exit;
	KbdInstalled:=True;
	OldExitProc:=ExitProc;
	ExitProc:=@KbdAutoClose;
	GetIntVec($09,@OldInt09);
	SetIntVec($09,@Hooked09);
	For C:=1 To 255 Do
		Key[C]:=False;
End;

Procedure PixRemoveKey;
Begin
	If Not KbdInstalled Then Exit;
	KbdInstalled:=False;
	ExitProc:=OldExitProc;
	SetIntVec($09,@OldInt09);
End;

Procedure PixWaitForKey(WKey:Byte);
Begin
	Repeat Until Key[WKey];
	Repeat Until Not Key[WKey];
End;

Function PixWaitAnyKey:Byte;
Var
	C:Byte;
   Ext:Boolean;
Begin
	For C:=1 To 255 Do
   	Key[C]:=False;
   Ext:=False;
	Repeat
   	For C:=1 To 255 Do
      	If Key[C] Then
			Begin
         	Ext:=True;
				Break;
         End;
   Until Ext;
   Repeat Until Not Key[C];
	PixWaitAnyKey:=C;
End;

Function PixKeyPressed:Boolean;
Begin
	PixKeyPressed:=KeyPr;
   KeyPr:=False;
End;

Begin
	CtrlAltDelEnabled:=False;
   KbdInstalled:=False;
End.
