Unit Pix2Map;

{$I-}
{$G+}
{$R-}
{$Q-}

(* The {$DEFINE PIXDEBUG} should be here *)
{$DEFINE PIXDEBUG}


Interface

Type
   PixTileMap=Object
		MWd,MHg,TWd,THg,NumTil:Integer;
      Tiles:Array[0..255] Of Pointer;
      Map:Array[0..199,0..199] Of Byte;
      ScX,ScY,Wd,Hg:Integer;
   	Constructor Init(nScX,nScY,nWd,nHg:Integer);
      Procedure NewMap(nMWd,nMHg,nTWd,nTHg:Integer);
      Procedure Draw(VirX,VirY:Integer);
      Procedure Save(FName:String);
      Procedure Load(FName:String);
      Destructor Done;
   End;

Implementation

Uses
	Pix2Main;

Constructor PixTileMap.Init(nScX,nScY,nWd,nHg:Integer);
Begin
   ScX:=nScX;
   ScY:=nScY;
   Wd:=nWd;
   Hg:=nHg;
End;

Procedure PixTileMap.NewMap(nMWd,nMHg,nTWd,nTHg:Integer);
Var
	X,Y:Word;
Begin
	MWd:=nMWd;
   MHg:=nMHg;
   TWd:=nTWd;
   THg:=nTHg;
   NumTil:=0;
   For X:=0 To 199 Do
   	For Y:=0 To 199 Do
      	Map[X,Y]:=0;
End;

Procedure PixTileMap.Draw(VirX,VirY:Integer);
Var
	X,Y,X1,Y1,X2,Y2,fX,fY:Integer;
Begin
	X1:=VirX Div TWd;
   Y1:=VirY Div THg;
   If X1<0 Then X1:=0;
   If Y1<0 Then Y1:=0;
   X2:=X1+(Wd Div TWd)+1;
   Y2:=Y1+(Hg Div THg)+1;
   fX:=VirX Mod TWd;
   fY:=VirY Mod THg;
   If VirX<0 Then
   	fX:=(VirX Div TWd)*TWd+fX;
   If VirY<0 Then
   	fY:=(VirY Div THg)*THg+fY;
   If X2>=MWd Then X2:=MWd-1;
   If Y2>=MHg Then Y2:=MHg-1;
   For Y:=Y1 To Y2 Do
   	For X:=X1 To X2 Do Begin
      	PixPutImage(Tiles[Map[X,Y]],ScX-fX+(X-X1)*TWd,ScY-fY+(Y-Y1)*THg,False);
		End;
End;

Procedure PixTileMap.Save(FName:String);
Var
	F:File;
   W:Word;
   C:Integer;
Begin
   If Pos('.',FName)=0 Then
   	FName:=FName+'.PTM';
	Assign(F,FName);
   ReWrite(F,1);
   W:=1234;
   BlockWrite(F,W,2);
   BlockWrite(F,NumTil,2);
   BlockWrite(F,MWd,2);
   BlockWrite(F,MHg,2);
   BlockWrite(F,TWd,2);
   BlockWrite(F,THg,2);
	For C:=0 To NumTil-1 Do
   	BlockWrite(F,Tiles[C]^,(TWd*THg)+4);
   BlockWrite(F,Map,200*200);
   Close(F);
   If IOResult>0 Then
   	;
End;

Procedure PixTileMap.Load(FName:String);
Var
	F:File;
   W:Word;
   C:Integer;
Begin
   If Pos('.',FName)=0 Then
   	FName:=FName+'.PTM';
	Assign(F,FName);
   Reset(F,1);
   BlockRead(F,W,2);
   If W<>1234 Then
   Begin
   	Close(F);
      Exit;
   End;
   If IOResult>0 Then
   	Exit;
   BlockRead(F,NumTil,2);
   BlockRead(F,MWd,2);
   BlockRead(F,MHg,2);
   BlockRead(F,TWd,2);
   BlockRead(F,THg,2);
	For C:=0 To NumTil-1 Do
   Begin
      GetMem(Tiles[C],TWd*THg+4);
   	BlockRead(F,Tiles[C]^,(TWd*THg)+4);
   End;
   BlockRead(F,Map,200*200);
   Close(F);
   If IOResult>0 Then
   	;
End;

Destructor PixTileMap.Done;
Var
	C:Byte;
Begin
	For C:=0 To NumTil-1 Do
   	PixDeAllocImage(Tiles[C]);
End;

End.
