Unit Pix2Mous;

{$I-}
{$G+}
{$R-}
{$Q-}

(* The {$DEFINE PIXDEBUG} should be here *)
{$DEFINE PIXDEBUG}

Interface

{ Mouse management functions }
Function PixResetMouse:Boolean;
Function PixGetButNum:Integer;
Function PixMouseIdle:Boolean;
Procedure PixShowMouse;
Procedure PixHideMouse;
Procedure PixDrawMouse;
Procedure PixLoadCursor(CurFile:String;NHX,NHY:Integer);
Procedure PixDeAllocCursor;

Var
	MouseX,MouseY:Integer;
	MouseB1,MouseB2,MouseB3:Boolean;
	MouseVisible:Boolean;
	Cur,Bkg:Pointer;

Implementation

Uses
	Pix2Main;

Var
	RAX,RBX,RCX,RDX:Integer;
	HotSpotX,HotSpotY:Integer;
	BkX,BkY:Integer;
	CurAllocated:Boolean;

Procedure CallMouse;
Begin
	Asm
		mov AX,RAx
		mov BX,RBx
		mov CX,RCx
		mov DX,RDx
		int 33h
		mov RAx,AX
		mov RBx,BX
		mov RCx,CX
		mov RDx,DX
	End;
End;

Function PixResetMouse:Boolean;
Begin
	RAX:=0;
	MouseX:=0;
	MouseY:=0;
	HotSpotX:=0;
	HotSpotY:=0;
	CallMouse;
	PixResetMouse:=RAX=$FFFF;
	MouseB1:=False;
	MouseB2:=False;
	MouseVisible:=False;
	CurAllocated:=False;
End;

Function PixGetButNum:Integer;
Begin
	RAX:=$0011;
	CallMouse;
	PixGetButNum:=RBX;
End;

Function PixMouseIdle:Boolean;
Var
	Motion:Boolean;
Begin
	PixMouseIdle:=False;
	RAX:=$000B;
	CallMouse;
	Motion:=False;
	If RCX<>0 Then
	Begin
		PixMouseIdle:=True;
		Inc(MouseX,RCX);
		If MouseX<0 Then MouseX:=0;
		If MouseX>319 Then MouseX:=319;
		Motion:=True;
	End;
	If RDX<>0 Then
	Begin
		PixMouseIdle:=True;
		Inc(MouseY,RDX);
		If MouseY<0 Then MouseY:=0;
		If MouseY>199 Then MouseY:=199;
		Motion:=True;
	End;
	RAX:=$0003;
	CallMouse;
	If (RBX And 1=1) Then
		MouseB1:=True
	Else
		MouseB1:=False;
	If (RBX And 2=2) Then
		MouseB2:=True
	Else
		MouseB2:=False;
	If (RBX And 4=4) Then
		MouseB3:=True
	Else
		MouseB3:=False;
	If Motion Then
		PixDrawMouse;
End;

Procedure PixShowMouse;
Var
	OS,OO:Word;
	Wd,Hg:Integer;
	OP:Byte;
Begin
	If MouseVisible Then Exit;
	If Not CurAllocated Then Exit;
	OS:=Seg(Cur^);
	OO:=Ofs(Cur^);
	Asm
		push DS
		mov AX,OS
		mov DS,AX
		mov SI,OO
		lodsw
		mov Wd,AX
		lodsw
		mov Hg,AX
		pop DS
	End;
	OP:=PixGetPage;
	PixSelPage(0);
	BkX:=MouseX-HotSpotX;
	BkY:=MouseY-HotSpotY;
	PixGetImage(Bkg,BkX,BkY,BkX+Wd-1,BkY+Hg-1,False);
	PixPutImage(Cur,MouseX-HotSpotX,MouseY-HotSpotY,True);
	MouseVisible:=True;
	PixSelPage(OP);
End;

Procedure PixHideMouse;
Var
	OP:Byte;
Begin
	If Not MouseVisible Then Exit;
	If Not CurAllocated Then Exit;
	OP:=PixGetPage;
	PixSelPage(0);
	PixPutImage(Bkg,BkX,BkY,False);
	MouseVisible:=False;
	PixSelPage(OP);
End;

Procedure PixDrawMouse;
Var
	OS,OO:Word;
	OP:Byte;
	Wd,Hg:Word;
Begin
	If Not MouseVisible Then Exit;
	If Not CurAllocated Then Exit;
	OS:=Seg(Cur^);
	OO:=Ofs(Cur^);
	Asm
		push DS
		mov AX,OS
		mov DS,AX
		mov SI,OO
		lodsw
		mov Wd,AX
		lodsw
		mov Hg,AX
		pop DS
	End;
	OP:=PixGetPage;
	PixSelPage(0);
	PixPutImage(Bkg,BkX,BkY,False);
	BkX:=MouseX-HotSpotX;
	BkY:=MouseY-HotSpotY;
	PixGetImage(Bkg,BkX,BkY,BkX+Wd-1,BkY+Hg-1,False);
	PixPutImage(Cur,MouseX-HotSpotX,MouseY-HotSpotY,True);
	PixSelPage(OP);
End;

Procedure PixLoadCursor(CurFile:String;NHX,NHY:Integer);
Var
	F:File;
Begin
	If CurAllocated Then
	Begin
		PixDeAllocImage(Cur);
		PixDeAllocImage(Bkg);
	End;
	PixLoadPri(Cur,CurFile);
	PixLoadPri(Bkg,CurFile);
	CurAllocated:=True;
	HotSpotX:=NHX;
	HotSpotY:=NHY;
End;

Procedure PixDeAllocCursor;
Begin
	If Not CurAllocated Then
		Exit;
	PixDeAllocImage(Cur);
	PixDeAllocImage(Bkg);
	CurAllocated:=False;
End;

Begin
	PixResetMouse;
End.