Unit Pix2Text;

{$I-}
{$G+}
{$R-}
{$Q-}

(* The {$DEFINE PIXDEBUG} should be here *)
{$DEFINE PIXDEBUG}

Interface

Type
	PixFont=Record
		Fnt:Array[1..127,1..8,1..8] Of Byte;
		Sx,Sy:Byte;
		Ix,Iy:Array[1..127] Of Byte;
		MonoFont:Boolean;
	End;

{ Functions to display text }
Procedure PixLoadFont(FName:String);
Procedure PixSaveFont(FName:String);
Procedure PixLoadDefaultFont;
Procedure PixLoadROMFont;
Procedure PixWrite(X,Y:Integer;Col:Byte;St:String);
Procedure PixWriteCenter(Y:Integer;Col:Byte;St:String);
Procedure PixWriteS(X,Y:Integer;Col,SCol:Byte;St:String);
Procedure PixWriteCenterS(Y:Integer;Col,SCol:Byte;St:String);
Function PixLength(St:String):Word;
Function PixHeight(St:String):Byte;
Procedure PutIt(X,Y:Integer;Col:Byte;Car:Byte);

Var
	Font:PixFont;

Implementation

Uses
	Pix2Main;

Procedure SmallFont; External;
{$L SMALLFNT.OBJ}

Procedure PutIt(X,Y:Integer;Col:Byte;Car:Byte);
Var
	P:Array[0..67] of Byte;
	C,Xe:Integer;
	Cx:Integer;
Begin
	{$IFDEF PIXDEBUG}
		If Car>127 Then
		Begin
			PixClose;
			PixScreen('Programming error occured');
			WriteLn('Invalid character in one of the PixWriteXXX function.');
			Halt(0);
		End;
	{$ENDIF}
	P[0]:=Font.Ix[Car];
	P[1]:=0;
	P[2]:=Font.Iy[Car];
	P[3]:=0;
	Cx:=4;
	For C:=1 To Font.Iy[Car] Do
	Begin
		If Font.MonoFont Then
		Begin
			For Xe:=1 To Font.Ix[Car] Do
				If Font.Fnt[Car,C,Xe]<>0 Then
					P[Cx+Xe-1]:=Col
				Else
					P[Cx+Xe-1]:=0;
		End
		Else
			Move(Font.Fnt[Car,C,1],P[Cx],Font.Ix[Car]);
		Inc(Cx,Font.Ix[Car]);
	End;
	PixPutImage(@P,X,Y,True);
End;

Procedure PixLoadFont(FName:String);
Var
	F:File;
Begin
	If Pos('.',FName)=0 Then
		FName:=FName+'.FNT';
	Assign(F,FName);
	Reset(F,1);
	If IOResult>0 Then
	Begin
		PixClose;
		PixScreen('I/O Error');
		WriteLn('File ',FName,' not found.');
		Halt(0);
	End;
	BlockRead(F,Font,SizeOf(Font));
	Close(F);
	If IOResult>0 Then
	Begin
		PixClose;
		PixScreen('I/O Error');
		WriteLn('Unable to read in ',FName);
		Halt(0);
	End;
End;

Procedure PixSaveFont(FName:String);
Var
	F:File;
Begin
	If Pos('.',FName)=0 Then
		FName:=FName+'.FNT';
	Assign(F,FName);
	Rewrite(F,1);
	If IOResult>0 Then
	Begin
		PixClose;
		PixScreen('I/O Error');
		WriteLn('Unable to create ',FName);
		Halt(0);
	End;
	BlockWrite(F,Font,SizeOf(Font));
	Close(F);
	If IOResult>0 Then
	Begin
		PixClose;
		PixScreen('I/O Error');
		WriteLn('Unable to write in ',FName);
		Halt(0);
	End;
End;

Procedure PixWrite(X,Y:Integer;Col:Byte;St:String);
Var
	C:Integer;
Begin
	For C:=1 To Length(St) Do
	Begin
		PutIt(X,Y,Col,Ord(St[C]));
		Inc(X,Font.Ix[Ord(St[C])]+1);
	End;
End;

Procedure PixWriteCenter(Y:Integer;Col:Byte;St:String);
Var
	X,C:Integer;
Begin
	X:=160-(PixLength(St) div 2);
	For C:=1 To Length(St) Do
	Begin
		PutIt(X,Y,Col,Ord(St[C]));
		Inc(X,Font.Ix[Ord(St[C])]+1);
	End;
End;

Procedure PixWriteS(X,Y:Integer;Col,SCol:Byte;St:String);
Begin
	PixWrite(X+1,Y+1,SCol,St);
	PixWrite(X,Y,Col,St);
End;

Procedure PixWriteCenterS(Y:Integer;Col,SCol:Byte;St:String);
Var
	X,C:Integer;
Begin
	X:=160-(PixLength(St) div 2)+1;
	For C:=1 To Length(St) Do
	Begin
		PutIt(X,Y+1,sCol,Ord(St[C]));
		Inc(X,Font.Ix[Ord(St[C])]+1);
	End;
	PixWriteCenter(Y,Col,St);
End;

Function PixLength(St:String):Word;
Var
	C:Byte;
	T:Word;
Begin
	T:=0;
	For C:=1 To Length(St) Do
		T:=T+Font.Ix[Ord(St[C])]+1;
	PixLength:=T;
End;

Function PixHeight(St:String):Byte;
Var
	C,I:Integer;
Begin
	I:=0;
	For C:=1 To Length(St) Do
		If Font.Iy[Ord(St[C])]>I Then
			I:=Font.Iy[Ord(St[C])];
	PixHeight:=I;
End;

Procedure PixLoadDefaultFont;
Begin
	Move(Pointer(@SmallFont)^,Font,SizeOf(Font));
End;

Procedure PixLoadROMFont;
Var
	C,D:Byte;
	B:Byte;
Begin
	Font.Sx:=8;
	Font.Sy:=8;
	Font.MonoFont:=True;
	For C:=1 To 127 Do
	Begin
		Font.Ix[C]:=8;
		Font.Iy[C]:=8;
	End;
	For C:=1 To 127 Do
	Begin
		For D:=1 To 8 Do
		Begin
			B:=Byte(Ptr($F000,$FA6E+(C*8)+D-1)^);
			Font.Fnt[C,D,1]:=Ord((B And $80)>0);
			Font.Fnt[C,D,2]:=Ord((B And $40)>0);
			Font.Fnt[C,D,3]:=Ord((B And $20)>0);
			Font.Fnt[C,D,4]:=Ord((B And $10)>0);
			Font.Fnt[C,D,5]:=Ord((B And $08)>0);
			Font.Fnt[C,D,6]:=Ord((B And $04)>0);
			Font.Fnt[C,D,7]:=Ord((B And $02)>0);
			Font.Fnt[C,D,8]:=Ord((B And $01)>0);
		End;
	End;
End;

Begin
	PixLoadDefaultFont;
End.